#include "RobboLito.h"
#include <string.h>
#include "sorvegliare.h"

static void
opzione (char *string)
{
  char *v;
  int i, valu;
  if (!memcmp (string, "TranspositionalTabularSizing", 28))
    {
      v = strstr (string, "value");
      if (v)
	{
	  valu = atoi (v + 6);
	  valu = inizializzazione_zobrist (valu);
	  TRASMISSIONE ("Optional TranspositionalTabularSizing %d\n", valu);
	}
    }
  if (!memcmp (string, "PawnsZobrist", 12))
    {
      v = strstr (string, "value");
      if (v)
	{
	  valu = atoi (v + 6);
	  valu = pedone_zobrist_inizializzazione (valu);
	  TRASMISSIONE ("Optional PawnsZobrist %d\n", valu);
	}
    }
  if (!memcmp (string, "MultiPV", 7))
    {
      v = strstr (string, "value");
      if (v)
	{
	  valu = atoi (v + 6);
	  MULTI_PV = valu;
	  if (MULTI_PV <= 1)
	    MULTI_PV = 1;
	  if (MULTI_PV >= 250)
	    MULTI_PV = 250;
	  TRASMISSIONE ("Optional MultiPV %d (beta funzione)\n", MULTI_PV);
	}
    }
  if (!memcmp (string, "MultiCentiPawnPV", 16))
    {
      v = strstr (string, "value");
      if (v)
	{
	  valu = atoi (v + 6);
	  MULTI_CENTI_PAWN_PV = valu;
	  if (MULTI_CENTI_PAWN_PV <= 1)
	    MULTI_CENTI_PAWN_PV = 1;
	  if (MULTI_CENTI_PAWN_PV >= 65535)
	    MULTI_CENTI_PAWN_PV = 65535;
	  TRASMISSIONE ("Optional MultiCentiPawnPV %d (beta funzione)\n", MULTI_CENTI_PAWN_PV);
	}
    }
  if (!memcmp (string, "TitanicCPUsSizings", 18))
    {
      v = strstr (string, "value");
      if (v)
	{
	  valu = atoi (v + 6);
	  if (valu <= 0)
	    valu = 1;
	  if (valu > 64)
	    valu = 64;
	  if (valu > MAX_CPUS)
	    valu = MAX_CPUS;
	  CPUS_SIZE = valu;
	  TRASMISSIONE ("Optional TitanicCPUsSizings (Capitalist!) %d\n", valu);
	}
    }
  if (!memcmp (string, "TitanicMode", 11))
    {
      v = strstr (string, "value");
      if (v)
	{
	  if (!strcmp (v + 6, "false"))
	    TITANIC_MODE = FALSO;
	  if (!strcmp (v + 6, "true"))
	    TITANIC_MODE = VERO;
	}
    }
}

static void
uci ()
{
  TRASMISSIONE ("id name %s verzione %s\n", EPONYM, VERSION);
  TRASMISSIONE ("id author Yakov Petrovich Golyadkin, ");
  TRASMISSIONE ("Igor Igorovich Igoronov, Roberto Pescatore, ");
  TRASMISSIONE ("Yusuf Ralf Weisskopf, ");
  TRASMISSIONE ("Ivan Skavinsky Skavar plus Decembrists (all)\n");
  TRASMISSIONE ("id copyright Yakov Petrovich Golyadkin, "
		"92th plus 93th year from Revolution, PUBLICDOMAIN (workers)\n");
  TRASMISSIONE ("id dedication To Vladimir Ilyich\n");
  TRASMISSIONE
    ("option name TranspositionalTabularSizing (Zobrist) in MegaBytes.");
  TRASMISSIONE (" Note: Only dyadic powers suffice terminally! ");
  TRASMISSIONE ("type spin min 1 max 16384 default 32\n");
  TRASMISSIONE ("option name PawnsZobrist in MegaBytes.");
  TRASMISSIONE (" Note: Only dyadic powers suffice terminally! ");
  TRASMISSIONE ("type spin min 1 max 1024 default 2\n");
  TRASMISSIONE ("option name TitanicMode (Capitalist!) type check default false\n");
  TRASMISSIONE ("option name TitanicCPUsSizings (Capitalist!) type spin min 1 max %d default 1\n", MAX_CPUS);
  TRASMISSIONE ("option name MultiPV type spin min 1 max 250 default 1\n");
  TRASMISSIONE ("option name MultiCentiPawnPV type spin min 1 max 65535 default 65535\n");
  TRASMISSIONE ("uciok\n");
}

static void
readyok ()
{
  TRASMISSIONE ("readyok\n");
}

static void
quit ()
{
  exit (0);
}

static void
ingresso_analizi (tipo_posizione *POSIZIONE, char *I)
{
  if (!strcmp (I, "quit"))
    quit ();
  if (!strcmp (I, "stop"))
    cerca_alt (0);
  if (!strcmp (I, "isready"))
    readyok ();
  if (!strcmp (I, "ponderhit"))
    ponderhit ();
  if (!strcmp (I, "ucinewgame"))
    {
      cerca_alt (0);
      partita_nuova (POSIZIONE, VERO);
    }
  if (salto_ok)
    return;
#ifdef UTILITIES
  if (!memcmp (I, "perft-check", 11))
    Perfd (POSIZIONE, atoi (I+12), atoi (I+14)); /* HACK */
  if (!memcmp (I, "perft ", 6))
    PERFD (POSIZIONE, atoi (I+6));
#endif
  if (!memcmp (I, "go", 2))
    {
      cerca_inizializzazione (POSIZIONE, I);
      if (bordo_legittimo)
	cerca (POSIZIONE);
    }
  if (!memcmp (I, "position", 8))
    posizionale_inizializzazione (POSIZIONE, I + 9);
  if (!memcmp (I, "setoption name", 14))
    opzione (I + 15);
  if (!strcmp (I, "uci"))
    uci ();
}

void
ingresso (tipo_posizione *POSIZIONE)
{
  char I[65536];
  fgets (I, 65536, stdin);
  I[strlen (I) - 1] = 0;
  ingresso_analizi (POSIZIONE, I);
}
