
#ifdef UTILITIES
#include "RobboLito.h"

void drawboard (tipo_posizione* POSIZIONE)
{
  char C[16] = "0PNKBBRQ";
  int t, c, u;
  printf ("      +---+---+---+---+---+---+---+---+\n");
  for (t = T8; t >= T1; t--)
    {
      printf("   %i  |", t+1);
      for (c = CA; c <= CH; c++)
       {
	 u = POSIZIONE->qu[c + 8 * t];
	 if (u >= 8)
	   printf ("<%c>", C[u - 8]);
	 else if (u > 0)
	   printf (" %c ", C[u]);
	 else if ((c + t) & 1)
	   printf ("   ");
	 else
	   printf (" . ");
	 printf ("|");
       }
      printf ("\n      +---+---+---+---+---+---+---+---+\n");
    }
  printf ("        a   b   c   d   e   f   g   h\n");
}

uint64 CNT[64];
#define IN_CHECK (POSIZIONE->bianco_en_mossa ? \
		  POSIZIONE->DIN->bianco_re_scacco : \
		  POSIZIONE->DIN->nero_re_scacco)
#define ILLEGAL (!POSIZIONE->bianco_en_mossa ? \
		 POSIZIONE->DIN->bianco_re_scacco : \
		 POSIZIONE->DIN->nero_re_scacco)

static void perft (tipo_posizione* POSIZIONE, int d, int h)
{
  tipo_lista_mossa LM[256], *lm;
  int i;
  if (IN_CHECK)
    lm = evasione_mossa (POSIZIONE, LM, 0xffffffffffffffff);
  else
    {
      lm = cattura_mossa (POSIZIONE, LM, POSIZIONE->occupato_nero_bianco);
      lm = ordinaria_mossa (POSIZIONE, lm);
    }
  for (i = 0; i < lm - LM; i++)
    {
      fare (POSIZIONE, LM[i].mossa);
      mobilita (POSIZIONE);
      if (!ILLEGAL)
	{
	  CNT[h]++;
	  if (d > 1)
	    perft (POSIZIONE, d - 1, h + 1);
	}
      annullare (POSIZIONE, LM[i].mossa);
    }
}

void PERFT (tipo_posizione* POSIZIONE, int d)
{
  int i;
  mobilita (POSIZIONE);
  for (i = 0; i < 64; i++)
    CNT[i] = 0;
  perft (POSIZIONE, d, 1);
  for (i = d; i >= 2; i--)
    printf ("%lld/", CNT[i]);
  printf ("%lld\n", CNT[1]);
}

uint64 PERFD (tipo_posizione* POSIZIONE, int n)
{
  int i;
  uint64 TOTAL = 0,TIME;
  tipo_lista_mossa LM[256], *lm;
  drawboard (POSIZIONE);
  TIME = orologio();
  mobilita (POSIZIONE);
  if (IN_CHECK)
    lm = evasione_mossa (POSIZIONE, LM, 0xffffffffffffffff);
  else
    {
      lm = cattura_mossa (POSIZIONE, LM, POSIZIONE->occupato_nero_bianco);
      lm = ordinaria_mossa (POSIZIONE, lm);
    }
  for (i = 0; i < lm - LM; i++)
    {
      fare (POSIZIONE, LM[i].mossa);
      mobilita (POSIZIONE);
      if (!ILLEGAL)
	{
	  printf ("%s ",mossa_notazione (LM[i].mossa, STRING1));
	  PERFT (POSIZIONE, n - 1);
	  TOTAL += CNT[n - 1];
	}
      annullare (POSIZIONE, LM[i].mossa);
    }
  printf ("TOTAL %lld  moves %ld  time: %lld us\n",
	  TOTAL, lm - LM, orologio() - TIME);
  return TOTAL;
}

void Perfd (tipo_posizione* POSIZIONE, int d, uint64 n)
{
  uint64 u = PERFD (POSIZIONE, d);
  if (u != n)
    ERRORE ("Perfd failed: computed: %lld given: %lld",u,n);
}
#endif

