
#include "RobboLito.h"
#include <string.h>
#include "sorvegliare.h"

static sint64 INVIO;
static sint64 ORA_ASSOLUTA, ORA_DESIDERATA, INCREMENTO;
static int ABISSO;

#if 0
#define ORA_ALTERNATIVO VERO /* en UCI ? */
#endif

void ponderhit() /* ORA_ASSOLUTA se cambia ? */
{
  if (!DO_PONDER)
    return;
  PONDER_HIT = VERO;
  DO_PONDER = FALSO;
#if 1 /* ? */
  ORA_ASSOLUTA += orologio() - OROLOGIO;
#endif
}

void
cerca_alt (int tr)
{
  ALT = VERO;
  if (salto_ok)
    longjmp (J, 1);
}

void
notizia (sint64 x)
{
  uint64 t, nps, NODOS = 0;
  int cpu, rp;
  clock_t u;
  if (TITANIC_MODE)
    for (cpu = 0; cpu < CPUS_SIZE; cpu++)
      for (rp = 0; rp < RP_PER_CPU ; rp++)
        NODOS += ROOT_POSIZIONE[cpu][rp].nodes;
  else
    NODOS = ROOT_POSIZIONE0->nodes;
  u = clock ();
  INVIO = x;
  t = x / 1000;
  if (t == 0)
    nps = 0;
  else
    nps = NODOS / t;
  u = clock () - MOMENTO;
  TRASMISSIONE ("info time %lld nodes %lld nps %lld cpuload %d\n",
		t, NODOS, nps * 1000,
		(int) ((double) u / (double) x * 1000.0));
}

static sint64 ORA_BATTAGLIA, ORA_FACILE, ORA_ORDINARIA;

#ifdef ORA_ALTERNATIVO
int mossa_en_kontrol, ora_en_totale_bianco, ora_en_totale_nero,old_mtg;
logico INCREASED_DEPTH;
float time_factor;
#endif

void
risolvere_termine (tipo_posizione *POSIZIONE, int d)
{
  sint64 x;
  if (!salto_ok)
    return;
  x = orologio () - OROLOGIO;
  if (d == ABISSO)
    cerca_alt (1);
  if (x - INVIO > 1000000)
    notizia (x);
#if 1
  if (DO_PONDER)
    goto FINALE; /* Decembrist */
  if (DO_INFINITE)
    goto FINALE; /* Decembrist */
#endif
  if (d >= 1 && d < 8)
    goto FINALE;
  if (x > ORA_ASSOLUTA)
    cerca_alt (1);
  if (d == 0)
    goto FINALE;
#ifdef ORA_ALTERNATIVO
#define INCREASE_DEPTH() { INCREASED_DEPTH = VERO; goto FINALE; }
#define CHECK_INCREASE_DEPTH()
{ if (INCREASED_DEPTH && time_factor > 1.05) INCREASE_DEPTH (); cerca_alt (2); }
  if (!MOSSA_BRUTTA && x >= ORA_BATTAGLIA)
    CHECK_INCREASE_DEPTH();
  if (FACILE && x >= ORA_FACILE)
    CHECK_INCREASE_DEPTH();
  if (!MOSSA_BATTAGLIA && x >= ORA_ORDINARIA && !MOSSA_BRUTTA)
    CHECK_INCREASE_DEPTH();
#else
  if (!MOSSA_BRUTTA && x >= ORA_BATTAGLIA)
    cerca_alt (2);
  if (FACILE && x >= ORA_FACILE)
    cerca_alt (3);
  if (!MOSSA_BATTAGLIA && x >= ORA_ORDINARIA && !MOSSA_BRUTTA)
    cerca_alt (4);
#endif
 FINALE:
  while (interrogativo_ingresso ())
    ingresso (POSIZIONE);
}

#define INFINITO 0x7ffffffffffffff /* sint64 */
#define STRTOK(p) p = strtok (NULL, " ")

static uint32
mossa_completa (tipo_posizione *POSIZIONE, uint32 x)
{
  int pezzo, ai = AI (x), di = DI (x);
  if (!x)
    return x;
  pezzo = POSIZIONE->qu[di];
  if (pezzo == conto_re_bianco || pezzo == conto_re_nero)
    {
      if (ai - di == 2 || di - ai == 2)
        x |= pietra_arrocco;
    }
  if (AI (x) != 0 && AI (x) == DINAMICO->en_passant
      && (pezzo == conto_pedone_bianco || pezzo == conto_pedone_nero))
    x |= pietra_en_passant;
  return x;
}

static uint32 numeric_move (tipo_posizione* POSIZIONE, char* str)
{
  int x;
  x = mossa_completa (POSIZIONE, (str[2] - 'a') + ((str[3] - '1') << 3) +
		      ((str[0] - 'a') << 6) + ((str[1] - '1') << 9));
  if (str[4] == 'b')
    x |= pietra_promozione_alfiere;
  if (str[4] == 'n')
    x |= pietra_promozione_cavallo;
  if (str[4] == 'r')
    x |= pietra_promozione_torre;
  if (str[4] == 'q')
    x |= pietra_promozione_donna;
  return x;
}

#ifdef ORA_ALTERNATIVO
void
time_manager_009 (uint64 TOTAL_TIME, uint64 TIME, uint64 INCREMENT, int movestogo)
{
  TIME = MASSIMO (TIME - 500000, (9 * TIME) / 10);
  if (movestogo)
    {
      old_mtg = movestogo;
      time_factor = (float) (TIME * mossa_en_kontrol) / (float) (TOTAL_TIME * movestogo);
      if (time_factor < 1.0)
	ORA_DESIDERATA = TIME / movestogo + INCREMENT;
      else
	ORA_DESIDERATA =
	  MINIMO (TIME * time_factor * time_factor / movestogo + INCREMENT, TIME);
      if (time_factor < 1.2 && movestogo > 2)
	ORA_ASSOLUTA =
	  MINIMO ((TIME * time_factor * (movestogo + 2)) / (movestogo + 3),
		  6 * ORA_DESIDERATA);
      else
	ORA_ASSOLUTA = (TIME * (movestogo + 1)) / (movestogo + 2);
      ORA_ASSOLUTA = MASSIMO (10000, ORA_ASSOLUTA);
    }
#define NUMBER 4 /* or 6 ? */
  else /* no movestogo */
    {
      int temp = TIME / 20;
      float sf;
      if (temp > INCREMENT)
	{
	  ORA_DESIDERATA =
	    INCREMENT + (temp * TIME) / ((50 - NUMBER) * temp - 20 * INCREMENT);
	  ORA_ASSOLUTA = (temp * TIME) / (5 * temp - 3 * INCREMENT);
	}
      else
	{
	  ORA_ASSOLUTA = TIME >> 1;
	  ORA_ASSOLUTA = INCREMENT + TIME / (30 - NUMBER);
	}
      sf = (float) (TIME + 20 * INCREMENT) / (float) (TOTAL_TIME);
      if (6.0 * sf < 1.0)
	ORA_ASSOLUTA /= 2;
      else if (3.0 * sf < 1.0)
	ORA_ASSOLUTA *= (3.0 * sf);
      if (TIME < 500000)
	{
	  ORA_ASSOLUTA = 10000;
	  ORA_DESIDERATA = 5000;
	}
      if (TIME >= 500000 && TIME < 1000000 && INCREMENT < 500000)
	{
	  ORA_ASSOLUTA = (TIME * 5) / 100;
	  ORA_DESIDERATA = (TIME * 5) / 400;
	}
      if (TIME >= 1000000 && TIME < 2000000 && INCREMENT < 500000)
	{
	  ORA_ASSOLUTA = TIME / 10;
	}

    }
  ORA_FACILE = ORA_DESIDERATA >> 2;
  ORA_BATTAGLIA = ORA_DESIDERATA;
  ORA_ORDINARIA = (3 * ORA_DESIDERATA) >> 2;
}
#endif

void time_manager (uint64 ORA, uint64 INCREMENTO, int movestogo)
{  
  if (movestogo)
    {
      if (movestogo > 25)
	movestogo = 25;
      ORA_DESIDERATA = ORA / movestogo + INCREMENTO;
      ORA_ASSOLUTA =
	(ORA * movestogo) / (2 * movestogo - 1) - MINIMO (1000000, ORA / 10);
      if (ORA_ASSOLUTA < 5000)
	ORA_ASSOLUTA = 5000;
    }
  else
    {
      ORA_ASSOLUTA = ORA / 2 - 10000;
      if (ORA_ASSOLUTA < 5000)
	ORA_ASSOLUTA = 5000;
      ORA_DESIDERATA = ORA_ASSOLUTA / 22 + INCREMENTO;
    }
  if (ORA_DESIDERATA > ORA_ASSOLUTA)
    ORA_DESIDERATA = ORA_ASSOLUTA;
  if (ORA_DESIDERATA < 5000)
    ORA_DESIDERATA = 5000;

#if 1
  ORA_FACILE = ORA_DESIDERATA / 4;
  ORA_BATTAGLIA = ORA_DESIDERATA;
  ORA_ORDINARIA = (3 * ORA_DESIDERATA) / 4;
#else
  ORA_FACILE = ORA_DESIDERATA / 4;
  ORA_BATTAGLIA = ORA_DESIDERATA;
  ORA_ORDINARIA = (1 * ORA_DESIDERATA) / 2;
#endif
}

void
cerca_inizializzazione (tipo_posizione *POSIZIONE, char *str)
{
  char *p;
  sint64 ora_bianca = INFINITO, ora_nera = INFINITO,
    incremento_bianco = 0, incremento_nero = 0, ORA, movestogo = 0;
  int sm = 0;

  ABISSO = 255;
  ORA_ASSOLUTA = ORA_DESIDERATA = INFINITO;
  ALT = FALSO;
  DO_INFINITE = FALSO;
  DO_PONDER = FALSO;
  DO_SEARCH_MOVES = FALSO;
  INVIO = 0;
  p = strtok (str, " ");
  for (STRTOK (p); p != NULL; STRTOK (p))
    {
      if (!strcmp (p, "depth"))
	{
	  STRTOK (p);
	  ABISSO = MASSIMO (1, atoi (p));
	}
      else if (!strcmp (p, "movetime"))
	{
	  STRTOK (p);
	  ORA_ASSOLUTA = MASSIMO (1, atoll (p)) * 1000; /* - 10000 ? */
	}
      else if (!strcmp (p, "wtime"))
	{
	  STRTOK (p);
	  ora_bianca = atoll (p) * 1000;
	}
      else if (!strcmp (p, "winc"))
	{
	  STRTOK (p);
	  incremento_bianco = atoll (p) * 1000;
	}
      else if (!strcmp (p, "btime"))
	{
	  STRTOK (p);
	  ora_nera = atoll (p) * 1000;
	}
      else if (!strcmp (p, "binc"))
	{
	  STRTOK (p);
	  incremento_nero = atoll (p) * 1000;
	}
      else if (!strcmp (p, "movestogo"))
	{
	  STRTOK (p);
	  movestogo = atoi (p);
	}
      else if (!strcmp (p, "infinite"))
	DO_INFINITE =  VERO;
      else if (!strcmp (p, "ponder"))
	DO_PONDER = VERO;
      else if (!strcmp (p, "searchmoves"))
	DO_SEARCH_MOVES = VERO;
      else if (DO_SEARCH_MOVES)
	SEARCH_MOVES[sm++] = numeric_move (POSIZIONE, p);
      else
	ERRORE ("go string: %s", p);
    }
  ORA_BATTAGLIA = INFINITO;
  ORA_ORDINARIA = INFINITO;
  ORA_FACILE = INFINITO;
#ifdef ORA_ALTERNATIVO
  time_factor = 1.0;
  INCREASED_DEPTH = FALSO;
  if (PARTITA_NUOVA || movestogo > old_mtg) /* reset */
    {
      mossa_en_kontrol = movestogo;
      ora_en_totale_bianco = MASSIMO (ora_bianca - 500000, (95 * ora_bianca) / 100);
      ora_en_totale_nero = MASSIMO (ora_bianca - 500000, (95 * ora_nera) / 100);
    }
#endif
  ORA = POSIZIONE->bianco_en_mossa ? ora_bianca : ora_nera;
  if (ORA == INFINITO)
    goto FINALE;
  INCREMENTO =
    POSIZIONE->bianco_en_mossa ? incremento_bianco : incremento_nero;
#ifdef ORA_ALTERNATIVO
  time_manager_009
    (POSIZIONE->bianco_en_mossa ?
     ora_en_totale_bianco : ora_en_totale_nero,
     ORA, INCREMENTO, movestogo); /* alternativo */
#else
  time_manager (ORA, INCREMENTO, movestogo);
#endif
 FINALE:
  if (ORA == INFINITO)
    ANALISI = VERO;
  else
    ANALISI = FALSO;
  if (DO_SEARCH_MOVES)
    SEARCH_MOVES[sm] = MOSSA_NON;
}
