
#ifdef DEBUG
#include "RobboLito.h"
#define PIZZICA (0x74d3c012a8bf965e)
#include <signal.h>
#include "valore.i"
void validate (tipo_posizione* POSIZIONE, int x, uint32 mossa)
{
  int qu, pez;
  logico OK = VERO;
  uint32 STATICO = 0; /* en mejor sint32 ? */
  uint32 MATERIAL = 0;
  uint64 zZOBRIST = 0, ZOBRIST_PEDONE = 0;
  uint64 WHITE_OCCUPIED = 0, BLACK_OCCUPIED = 0, OCCUPIED;
  uint64 bitbordo[16];
  int bianco_re_quadretto, nero_re_quadretto;
  uint64 LEFT_45 = 0;
  uint64 RIGHT_45 = 0;
  uint64 LEFT_90 = 0;
  int b;
  for (pez = 0; pez < 16; pez++)
    bitbordo[pez] = 0;
  for (qu = A1; qu <= H8; qu++)
    if ((pez = POSIZIONE->qu[qu]))
      {
	bitFISSO (qu, bitbordo[pez]);
	STATICO += statico_valu[pez][qu];
	zZOBRIST ^= ZOBRIST[pez][qu];
	if (pez == conto_pedone_bianco || pez == conto_pedone_nero)
	  ZOBRIST_PEDONE ^= ZOBRIST[pez][qu];
	if (pez == conto_re_bianco)
	  bianco_re_quadretto = qu;
	if (pez == conto_re_nero)
	  nero_re_quadretto = qu;
	MATERIAL += valu_materiale[pez];
      }
  if ((MATERIAL & 0x7fffffff) != (POSIZIONE->DIN->materiale & 0x7fffffff))
    {
      OK = FALSO;
      printf ("Material: POSIZIONE %x board: %x\n", POSIZIONE->DIN->materiale, MATERIAL);
    }
  if (STATICO != POSIZIONE->DIN->statico)
    {
      OK = FALSO;
      printf ("Statico: POSIZIONE %x board: %x\n", POSIZIONE->DIN->statico, STATICO);
    }
    if (POPCNT (bitbordo[conto_re_bianco]) != 1 ||
      BSF (bitbordo[conto_re_bianco]) != bianco_re_quadretto ||
      POSIZIONE->bianco_re_quadretto != bianco_re_quadretto)
    {
      OK = FALSO;
      printf ("White King: POSIZIONE: %llx %d board: %llx %d\n",
	      POSIZIONE->bitbordo[conto_re_bianco],
	      POSIZIONE->bianco_re_quadretto,
	      bitbordo[conto_re_bianco],
	      bianco_re_quadretto);
    }
    if (POPCNT (bitbordo[conto_re_nero]) != 1 ||
      BSF (bitbordo[conto_re_nero]) != nero_re_quadretto ||
      POSIZIONE->nero_re_quadretto != nero_re_quadretto)
    {
      OK = FALSO;
      printf ("Black King: POSIZIONE: %llx %d board: %llx %d\n",
	      POSIZIONE->bitbordo[conto_re_nero],
	      POSIZIONE->nero_re_quadretto,
	      bitbordo[conto_re_nero],
	      nero_re_quadretto);
    }
    
  ZOBRIST_PEDONE ^= zobrist_oo[POSIZIONE->DIN->arrocco] ^ PIZZICA;
  ZOBRIST_PEDONE ^= ZOBRIST[conto_re_bianco][POSIZIONE->bianco_re_quadretto] ^
    ZOBRIST[conto_re_nero][POSIZIONE->nero_re_quadretto];
  if (ZOBRIST_PEDONE != POSIZIONE->DIN->ZobristPedone)
    {
      OK = FALSO;
      printf ("Zobrist Pedone: POSIZIONE: %llx board: %llx\n",
	      POSIZIONE->DIN->ZobristPedone, ZOBRIST_PEDONE);      
    }
  for (pez = 0; pez < 8; pez ++)
    WHITE_OCCUPIED |= bitbordo[pez];
  for (pez = 8; pez < 0x10; pez ++)
    BLACK_OCCUPIED |= bitbordo[pez];
  if (WHITE_OCCUPIED != bitbordo_occupato_bianco)
    {
      OK = FALSO;
      printf ("White Occupied: POSIZIONE: %llx board: %llx\n",
	      bitbordo_occupato_bianco, WHITE_OCCUPIED);
    }
  if (BLACK_OCCUPIED != bitbordo_occupato_nero)
    {
      OK = FALSO;
      printf ("Black Occupied: POSIZIONE: %llx board: %llx\n",
	      bitbordo_occupato_nero, BLACK_OCCUPIED);
    }
  if (bitbordo[conto_pedone_bianco] != bitbordo_bianco_pedone)
    {
      OK = FALSO;
      printf ("White Pawns: POSIZIONE: %llx board: %llx\n",
	      bitbordo[conto_pedone_bianco], bitbordo_bianco_pedone);
    }
  if (bitbordo[conto_cavallo_bianco] != bitbordo_bianco_cavallo)
    {
      OK = FALSO;
      printf ("White Knights: POSIZIONE: %llx board: %llx\n",
	      bitbordo[conto_cavallo_bianco], bitbordo_bianco_cavallo);
    }
  if (bitbordo[conto_chiaro_bianco] != bitbordo_bianco_chiaro)
    {
      OK = FALSO;
      printf ("White Light Bishops: POSIZIONE: %llx board: %llx\n",
	      bitbordo[conto_chiaro_bianco], bitbordo_bianco_chiaro);
    }
  if (bitbordo[conto_scuro_bianco] != bitbordo_bianco_scuro)
    {
      OK = FALSO;
      printf ("White Dark Bishops: POSIZIONE: %llx board: %llx\n",
	      bitbordo[conto_scuro_bianco], bitbordo_bianco_scuro);
    }
  if (bitbordo[conto_torre_bianco] != bitbordo_bianco_torre)
    {
      OK = FALSO;
      printf ("White Rooks: POSIZIONE: %llx board: %llx\n",
	      bitbordo[conto_torre_bianco], bitbordo_bianco_torre);
    }
  if (bitbordo[conto_donna_bianca] != bitbordo_bianca_donna)
    {
      OK = FALSO;
      printf ("White Queens: POSIZIONE: %llx board: %llx\n",
	      bitbordo[conto_donna_bianca], bitbordo_bianca_donna);
    }
  if (bitbordo[conto_pedone_nero] != bitbordo_nero_pedone)
    {
      OK = FALSO;
      printf ("Black Pawns: POSIZIONE: %llx board: %llx\n",
	      bitbordo[conto_pedone_nero], bitbordo_nero_pedone);
    }
  if (bitbordo[conto_cavallo_nero] != bitbordo_nero_cavallo)
    {
      OK = FALSO;
      printf ("Black Knights: POSIZIONE: %llx board: %llx\n",
	      bitbordo[conto_cavallo_nero], bitbordo_nero_cavallo);
    }
  if (bitbordo[conto_chiaro_nero] != bitbordo_nero_chiaro)
    {
      OK = FALSO;
      printf ("Black Light Bishops: POSIZIONE: %llx board: %llx\n",
	      bitbordo[conto_chiaro_nero], bitbordo_nero_chiaro);
    }
  if (bitbordo[conto_scuro_nero] != bitbordo_nero_scuro)
    {
      OK = FALSO;
      printf ("Black Dark Bishops: POSIZIONE: %llx board: %llx\n",
	      bitbordo[conto_scuro_nero], bitbordo_nero_scuro);
    }
  if (bitbordo[conto_torre_nero] != bitbordo_nero_torre)
    {
      OK = FALSO;
      printf ("Black Rooks: POSIZIONE: %llx board: %llx\n",
	      bitbordo[conto_torre_nero], bitbordo_nero_torre);
    }
  if (bitbordo[conto_donna_nera] != bitbordo_nera_donna)
    {
      OK = FALSO;
      printf ("Black Queens: POSIZIONE: %llx board: %llx\n",
	      bitbordo[conto_donna_nera], bitbordo_nera_donna);
    }
  OCCUPIED = WHITE_OCCUPIED | BLACK_OCCUPIED;
  if (OCCUPIED != POSIZIONE->occupato_nero_bianco)
    {
      OK = FALSO;
      printf ("Occupied: POSIZIONE: %llx board: %llx\n",
	      POSIZIONE->occupato_nero_bianco, OCCUPIED);
    }
  while (OCCUPIED)
    {
      b = BSF (OCCUPIED); bitLIBERO (b, OCCUPIED);
      bitFISSO (sinistro45[b], LEFT_45);
      bitFISSO (sinistro90[b], LEFT_90);
      bitFISSO (retto45[b], RIGHT_45);
    }
  if (LEFT_45 != POSIZIONE->occupato_sinistro45)
    {
      OK = FALSO;
      printf ("Left 45: POSIZIONE: %llx board: %llx\n",
	      POSIZIONE->occupato_sinistro45, LEFT_45);
    }
  if (LEFT_90 != POSIZIONE->occupato_sinistro90)
    {
      OK = FALSO;
      printf ("Left 90: POSIZIONE: %llx board: %llx\n",
	      POSIZIONE->occupato_sinistro90, LEFT_90);
    }
  if (RIGHT_45 != POSIZIONE->occupato_retto45)
    {
      OK = FALSO;
      printf ("Right 45: POSIZIONE: %llx board: %llx\n",
	      POSIZIONE->occupato_retto45, RIGHT_45);
    }
  zZOBRIST ^= zobrist_oo[POSIZIONE->DIN->arrocco];
  if (POSIZIONE->DIN->en_passant)
    zZOBRIST ^= zobrist_ep[POSIZIONE->DIN->en_passant & 7];
  if (POSIZIONE->bianco_en_mossa)
    zZOBRIST ^= zobrist_mossa_bianca;
  if (zZOBRIST != POSIZIONE->DIN->Zobrist)
    {
      OK = FALSO;
      printf ("Zobrist: POSIZIONE: %llx board: %llx\n",
	      POSIZIONE->DIN->Zobrist, zZOBRIST);
    }
  if (!OK)
    {
      printf ("x: %d mossa: %s\n", x, mossa_notazione (x, STRING1));
      raise (SIGTRAP);
    }
}
#endif
